import win32com.client
import string
from unicode_support import make_string
from com import ensure_init, _tmap_
import Zope


def valid_roles(self):
    "Return list of valid roles"

    root = self.getPhysicalRoot()
    has_adsgf = self.ZopeFind(root, obj_metatypes=['ADS Groups Folder'], search_sub=0)
    
    obj=self
    dict={}
    dup =dict.has_key
    x=0
    while x < 100:
        if hasattr(obj, '__ac_roles__'):
            roles=obj.__ac_roles__
            for role in roles:
                if not dup(role):
                    dict[role]=1
        if not hasattr(obj, 'aq_parent'):
            break
        obj=obj.aq_parent
        x=x+1
    roles=dict.keys()
    roles.sort()
    groupnames = []

    if has_adsgf:
        try:
            ensure_init()
            ads_folder_name, ads_folder_obj = has_adsgf[0]
            adsns = win32com.client.Dispatch('ADsNameSpaces')
            ldapns = adsns.GetObject('','LDAP:')
            adocon = win32com.client.Dispatch('ADODB.Connection')
            adocon.Provider = 'ADsDSOObject'
            adocon.Open('Active Directory Provider')
            attrs = ['samaccountname']
            cmd = win32com.client.Dispatch('ADODB.Command')
            cmd.ActiveConnection = adocon
            domain = ads_folder_obj.ldap_domain
            baseDN = ads_folder_obj.base_dn
            try:
                grpFilter = ads_folder_obj.search_filter
            except:
                grpFilter == None
            if grpFilter is not None:
                ldap_filter = '(&(objectclass=group)(|(samaccountname=domain*)(samaccountname=%s)))' % grpFilter
            else:
                ldap_filter = '(objectclass=group)'
            scope = ads_folder_obj.search_scope
            url = 'LDAP://%s/%s' % (domain, baseDN)
            cmd_text = '<%s>;%s;%s;%s' % (url, ldap_filter.strip(),
                                          ','.join(attrs), scope)
            cmd.CommandText = cmd_text
            
            rs = cmd.Execute()[0]
    
            if not rs.RecordCount:            
                return tuple(roles)
        
            rs.MoveFirst()
            
            while not rs.EOF:
                grpname = rs.Fields(0).Value
                groupnames.append(make_string(grpname))
                rs.MoveNext()
        
            groupnames.sort()
            return tuple(roles)+tuple(groupnames)
            
        except:
            return tuple(roles)+tuple(groupnames)
    else:
        return tuple(roles)