from ADSGroupsFolder import ADSGroupsFolder, manage_addADSGroupsFolderForm, manage_addADSGroupsFolder
from Globals import DTMLFile
from AccessControl.Role import RoleManager
from AccessControl.User import BasicUserFolder, SimpleUser

import Role, User

def initialize(context):
    context.registerClass(
    	ADSGroupsFolder,
    	constructors = (manage_addADSGroupsFolderForm, manage_addADSGroupsFolder)
    )

RoleManager.valid_roles = Role.valid_roles
SimpleUser.getRoles = User.getRoles 
BasicUserFolder._editUser = User._editUser
      
